//+----------------------------------------------------------+
//|                            Alternative_Ichimoku_v06.mq4  |
//|                 Copyright  february 2007          v.06  |
//|                 Lukashuk Victor Gennadievich aka lukas1  |
//+----------------------------------------------------------+
#property copyright "Copyright  2007, lukas1"
#property link ""
//----
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 LightPink
#property indicator_color2 LightSteelBlue
#property indicator_color3 LightPink
#property indicator_color4 LightSteelBlue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_color5 Blue
//---- input parameters

extern int    SSP             = 48;  
extern int    SSK             = 52;   // tolerance of the second line  

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = true;
extern string soundfile       = "alert2.wav";
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double Wal1[];
double Wal2[];
double ExtMapBuffer4[];
double trend[];


string comm;
double point = 0;
double pipMultiplier = 1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);
   SetIndexBuffer(0,ExtMapBuffer1);                                    SetIndexDrawBegin(0, SSP*2); SetIndexLabel(0,"priority line");
   SetIndexBuffer(1,ExtMapBuffer2);                                    SetIndexDrawBegin(1, SSP*2); SetIndexLabel(1,"overdue line");
   SetIndexBuffer(2,Wal1);            SetIndexStyle(2, DRAW_HISTOGRAM);SetIndexDrawBegin(2, SSP*2);
   SetIndexBuffer(3,Wal2);            SetIndexStyle(3, DRAW_HISTOGRAM);SetIndexDrawBegin(3, SSP*2);
   SetIndexBuffer(4,ExtMapBuffer4);                                    SetIndexDrawBegin(4, SSP*2); SetIndexLabel(4, "stop-order line");
   SetIndexBuffer(5,trend);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                          |
//+------------------------------------------------------------------+
void deinit() 
  {
   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   comm= ""; 
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(Digits==3 || Digits==5){point=Point*10;pipMultiplier=10;}else{point=Point;pipMultiplier=1;}

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      double SsMax     = High[iHighest(NULL,0,MODE_HIGH,SSP, i)];      
      double SsMin     = Low[iLowest(NULL,  0,MODE_LOW, SSP, i)];         
      double SsMax05   = High[iHighest(NULL,0,MODE_HIGH,SSP, i + SSK)];
      double SsMin05   = Low[iLowest(NULL,  0,MODE_LOW, SSP, i + SSK)]; 
         
      ExtMapBuffer1[i] = (SsMax + SsMin)   * 0.5;
      ExtMapBuffer2[i] = (SsMax05+SsMin05) * 0.5;
      double val1      = ExtMapBuffer1[i] / point;
      double val2      = ExtMapBuffer2[i] / point;
      
      double Rsmax     = High[iHighest(NULL,0,MODE_HIGH,SSP*2,i)]; 
      double Rsmin     = Low[iLowest(NULL,  0,MODE_LOW, SSP*2,i)];  
      double AvgRange  = (Rsmax / point) - (Rsmin / point);
       
               Wal1[i] = ExtMapBuffer1[i];
               Wal2[i] = ExtMapBuffer2[i];
      
      double Tsmax     = High[iHighest(NULL,0,MODE_HIGH,SSP*1.62,i)];     
      double Tsmin     = Low[iLowest(NULL,  0,MODE_LOW, SSP*1.62,i)];    
      ExtMapBuffer4[i] = (Tsmax + Tsmin) * 0.5;    
      trend[i] = trend[i+1];
      if (ExtMapBuffer1[i]>ExtMapBuffer4[i]) trend[i] = 1; 
      if (ExtMapBuffer2[i]>ExtMapBuffer4[i]) trend[i] =-1;  
      
     }
   int day_bars = MathCeil(1440 / Period());
   string sutki = "day";
// 
   if(Period() == 1440)  
     {
       sutki = "week";
       day_bars = 5;
     }  
// 
   if(Period() == 10080) 
     {
       sutki = "month"; 
       day_bars = 4;
     }  
// 
   if(Period() == 43200) 
     {
       sutki = "year";  
       day_bars = 12;
     } 
   int j = SSP*2 + 1;
   while(j >= 0)
      { 
        // find the daily range
        // max line of a day  
        double Day_max = High[iHighest(NULL, 0, MODE_HIGH, day_bars, j + 1)];  
        // min line of a day 
        double Day_min = Low[iLowest(NULL, 0, MODE_LOW, day_bars, j + 1)];      
        j--;
      }      
    
    int day_Range = (Day_max / point) - (Day_min / point); 
    int delta_from_max = (Day_max - Bid) / point;
    int delta_from_min = (Bid - Day_min) / point;
//----   
    comm = " parameters  SSP , SSK  =   " + SSP + " ,  " + SSK + " ;\n" +
           " volatility  (for " + SSP*2 + " bars) :      " + AvgRange + 
           "  .\n" + "\n" +
           " range for " + sutki + "  (for  " + day_bars + "  bars) :   " + 
           day_Range + "  .\n" +
           " deviation from maximum for " + sutki + ":  " + delta_from_max + 
           "  .\n" +
           " deviation from minimum for " + sutki + ":  " + delta_from_min + 
           "  .\n";            
    Comment(comm);
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("buy");
      else  doAlert("sell");       
   }
//----
   return(0);
  }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Alternative Ichimoku ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Alternative Ichimoku "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      

